{
  "openapi": "3.1.0",
  "info": {
    "title": "Forward Networks: Synthetic Devices API",
    "description": "Model a network’s internet connections, L2VPNs, and L3VPNs",
    "contact": {
      "email": "support@forwardnetworks.com"
    },
    "license": {
      "name": "MIT",
      "url": "https://spdx.org/licenses/MIT"
    },
    "version": "${apiVersion}"
  },
  "servers": [
    {
      "url": "/"
    }
  ],
  "security": [
    {
      "api_token": []
    }
  ],
  "tags": [
    {
      "name": "Synthetic Devices",
      "description": "Model a network’s internet connections, L2VPNs, and L3VPNs"
    }
  ],
  "paths": {
    "/api/networks/{networkId}/encryptors": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets a network's encryptors",
        "operationId": "getEncryptorsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EncryptorList"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Replaces all of a network’s encryptors",
        "operationId": "putEncryptorsUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EncryptorList"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      }
    },
    "/api/networks/{networkId}/encryptors/{deviceName}": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an encryptor",
        "operationId": "getEncryptorUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "deviceName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Encryptor"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds or replaces an encryptor",
        "operationId": "putEncryptorUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "deviceName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Encryptor"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an encryptor",
        "operationId": "deleteEncryptorUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "deviceName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "patch": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Updates an encryptor",
        "description": "All JSON properties in the request body are optional. Include only the properties you wish to change.",
        "operationId": "patchEncryptorUsingPATCH",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "deviceName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EncryptorPatch"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Encryptor"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/internet-node": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets the network’s internet node",
        "operationId": "getInternetNodeUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InternetNode"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Replaces the network’s internet node",
        "operationId": "putInternetNodeUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/InternetNode"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "patch": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Updates the network’s internet node",
        "description": "All JSON properties in the request body are optional. Include only the properties you wish to change.",
        "operationId": "updateInternetNodeUsingPATCH",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/InternetNodePatch"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/InternetNode"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/internet-node/connections": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets some internet node connections",
        "operationId": "getInternetNodeConnectionsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds a connection to the internet node",
        "operationId": "addInternetNodeConnectionUsingPOST",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/InetConnection"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes internet node connections",
        "operationId": "deleteInternetNodeConnectionsUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/intranet-nodes": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets a network’s intranet nodes",
        "operationId": "getIntranetNodesUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/IntranetNodeList"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Replaces all of a network’s intranet nodes",
        "operationId": "putIntranetNodesUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/IntranetNodeList"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      }
    },
    "/api/networks/{networkId}/intranet-nodes/{nodeName}": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an intranet node",
        "operationId": "getIntranetNodeUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/IntranetNode"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds or replaces an intranet node",
        "operationId": "putIntranetNodeUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/IntranetNode"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an intranet node",
        "operationId": "deleteIntranetNodeUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "patch": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Updates an intranet node",
        "description": "All JSON properties in the request body are optional. Include only the properties you wish to change.",
        "operationId": "patchIntranetNodeUsingPATCH",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/IntranetNodePatch"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/IntranetNode"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/intranet-nodes/{nodeName}/connections": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an intranet node’s connections",
        "operationId": "getIntranetNodeConnectionsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds a connection to an intranet node",
        "operationId": "addIntranetNodeConnectionUsingPOST",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/InetConnection"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an intranet node’s connections",
        "operationId": "deleteIntranetNodeConnectionsUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nodeName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/l2-vpns": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets a network’s L2VPNs",
        "operationId": "getL2VpnsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/L2VpnList"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Replaces all of a network’s L2VPNs",
        "operationId": "putL2VpnsUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L2VpnList"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      }
    },
    "/api/networks/{networkId}/l2-vpns/{l2VpnName}": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an L2VPN",
        "operationId": "getL2VpnUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/L2Vpn"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds or replaces an L2VPN",
        "operationId": "putL2VpnUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L2Vpn"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an L2VPN",
        "operationId": "deleteL2VpnUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "patch": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Updates an L2VPN",
        "description": "All JSON properties in the request body are optional. Include only the properties you wish to change.",
        "operationId": "patchL2VpnUsingPATCH",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L2VpnPatch"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/L2Vpn"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/l2-vpns/{l2VpnName}/connections": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an L2VPN’s connections",
        "operationId": "getL2VpnConnectionsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "device",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "port",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds a connection to an L2VPN",
        "operationId": "addL2VpnConnectionUsingPOST",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L2VpnConnection"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an L2VPN’s connections",
        "operationId": "deleteL2VpnConnectionsUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l2VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "device",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "port",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/l3-vpns": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets a network’s L3VPNs",
        "operationId": "getL3VpnsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/L3VpnList"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Replaces all of a network’s L3VPNs",
        "operationId": "putL3VpnsUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L3VpnList"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      }
    },
    "/api/networks/{networkId}/l3-vpns/{l3VpnName}": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an L3VPN",
        "operationId": "getL3VpnUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/L3Vpn"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds or replaces an L3VPN",
        "operationId": "putL3VpnUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L3Vpn"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an L3VPN",
        "operationId": "deleteL3VpnUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "patch": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Updates an L3VPN",
        "description": "All JSON properties in the request body are optional. Include only the properties you wish to change.",
        "operationId": "patchL3VpnUsingPATCH",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L3VpnPatch"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/L3Vpn"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/l3-vpns/{l3VpnName}/connections": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets an L3VPN’s connections",
        "operationId": "getL3VpnConnectionsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds a connection to an L3VPN",
        "operationId": "addL3VpnConnectionUsingPOST",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/L3VpnConnection"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes an L3VPN’s connections",
        "operationId": "deleteL3VpnConnectionsUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "l3VpnName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uplinkPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayDevice",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "gatewayPort",
            "in": "query",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "vlan",
            "in": "query",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SyntheticConnections"
                }
              }
            }
          }
        }
      }
    },
    "/api/networks/{networkId}/wan-circuits": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets a network’s WAN circuits",
        "operationId": "getWanCircuitsUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WanCircuitList"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Replaces all of a network’s WAN circuits",
        "operationId": "putWanCircuitsUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/WanCircuitList"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      }
    },
    "/api/networks/{networkId}/wan-circuits/{wanCircuitName}": {
      "get": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Gets a WAN circuit",
        "operationId": "getWanCircuitUsingGET",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "wanCircuitName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WanCircuit"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Adds or replaces a WAN circuit",
        "operationId": "putWanCircuitUsingPUT",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "wanCircuitName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/WanCircuit"
              }
            }
          },
          "required": true
        },
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "delete": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Removes a WAN circuit",
        "operationId": "deleteWanCircuitUsingDELETE",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "wanCircuitName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content",
            "content": {}
          }
        }
      },
      "patch": {
        "tags": [
          "Synthetic Devices"
        ],
        "summary": "Updates a WAN circuit",
        "description": "All JSON properties in the request body are optional. Include only the properties you wish to change.",
        "operationId": "patchWanCircuitUsingPATCH",
        "parameters": [
          {
            "name": "networkId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "wanCircuitName",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/WanCircuitPatch"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WanCircuit"
                }
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "AutoDiscoverySource": {
        "type": "string",
        "enum": [
          "NONE",
          "IP_ROUTES",
          "BGP_ROUTES",
          "INTERFACE_ADDRESSES"
        ]
      },
      "DevicePort": {
        "type": "object",
        "properties": {
          "device": {
            "type": "string"
          },
          "port": {
            "type": "string"
          }
        }
      },
      "Encryptor": {
        "type": "object",
        "required": [
          "name",
          "siteConnection",
          "tunnels"
        ],
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "encryptor"
            ]
          },
          "siteConnection": {
            "$ref": "#/components/schemas/EncryptorConnection",
            "description": "A connection to a high site"
          },
          "underlayConnection": {
            "$ref": "#/components/schemas/EncryptorConnection",
            "description": "A connection to the underlay network (a low site)"
          },
          "tunnels": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/EncryptorTunnel"
            },
            "description": "Tunnels to other encryptor devices. A tunnel source address is modeled as residing on this device and the destination addresses on another encryptor device. A source address may be reused on an encryptor. Each destination address must match the source address of the tunnel on another encryptor, and vice-versa"
          },
          "subnets": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "Subnets to route to the high site, in addition to the source addresses of tunnels on the `siteConnection` gateway device"
          }
        }
      },
      "EncryptorConnection": {
        "type": "object",
        "required": [
          "uplinkPort"
        ],
        "properties": {
          "uplinkPort": {
            "$ref": "#/components/schemas/DevicePort",
            "description": "The physical uplink port on the edge device.",
            "examples": [
              {
                "device": "nyc-rtr-01",
                "port": "eth1/1"
              }
            ]
          },
          "gatewayPort": {
            "$ref": "#/components/schemas/DevicePort",
            "description": "The virtual gateway port, if different than `uplinkPort`.",
            "examples": [
              {
                "device": "nyc-rtr-01",
                "port": "vlan100"
              }
            ]
          },
          "vlan": {
            "type": "integer",
            "format": "int32",
            "description": "The VLAN of traffic from `uplinkPort`, if tagged.",
            "examples": [
              100
            ]
          },
          "name": {
            "type": "string",
            "description": "An optional name for this connection, which will be used as the interface name created on the synthetic device that links to the physical edge port."
          }
        }
      },
      "EncryptorList": {
        "type": "object",
        "required": [
          "encryptors"
        ],
        "properties": {
          "encryptors": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Encryptor"
            }
          }
        }
      },
      "EncryptorPatch": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string"
          },
          "siteConnection": {
            "$ref": "#/components/schemas/EncryptorConnection"
          },
          "underlayConnection": {
            "$ref": "#/components/schemas/EncryptorConnection"
          },
          "tunnels": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/EncryptorTunnel"
            },
            "description": "If specified, this list will **replace** all existing tunnels on the encryptor."
          },
          "subnets": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "If specified, this set will **replace** all existing subnets on the encryptor."
          }
        }
      },
      "EncryptorTunnel": {
        "type": "object",
        "required": [
          "source",
          "destination"
        ],
        "properties": {
          "source": {
            "type": "string",
            "description": "Source IP address of an encryptor tunnel",
            "examples": [
              "1.1.1.1"
            ]
          },
          "destination": {
            "type": "string",
            "description": "Destination IP address of an encryptor tunnel",
            "examples": [
              "2.2.2.2"
            ]
          }
        }
      },
      "InetConnection": {
        "type": "object",
        "required": [
          "uplinkPort"
        ],
        "properties": {
          "uplinkPort": {
            "$ref": "#/components/schemas/DevicePort",
            "description": "The physical uplink port on the edge device.",
            "examples": [
              {
                "device": "nyc-rtr-01",
                "port": "eth1/1"
              }
            ]
          },
          "gatewayPort": {
            "$ref": "#/components/schemas/DevicePort",
            "description": "The virtual gateway port, if different than `uplinkPort`.",
            "examples": [
              {
                "device": "nyc-rtr-01",
                "port": "vlan100"
              }
            ]
          },
          "vlan": {
            "type": "integer",
            "format": "int32",
            "description": "The VLAN of traffic from `uplinkPort`, if tagged.",
            "examples": [
              100
            ]
          },
          "name": {
            "type": "string",
            "description": "An optional name for this connection, which will be used as the interface name created on the synthetic device that links to the physical edge port."
          },
          "site": {
            "type": "string",
            "description": "An optional name for the site in which this connection's gateway device resides. A site is a collection of devices that redistribute routes learned from an L3VPN to each other. Grouping connections together into a single site enables more accurate site subnet autodiscovery when using `IP_ROUTES` or `BGP_ROUTES`."
          },
          "subnets": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "Site subnets. Routes for these subnets are always created on the node. Required (and must not be empty) if `subnetAutoDiscovery` is `NONE`.",
            "examples": [
              "- 123.223.47.0/24"
            ]
          },
          "subnetAutoDiscovery": {
            "$ref": "#/components/schemas/AutoDiscoverySource",
            "description": "The source from which site subnets are automatically inferred from the gateway device. Defaults to `NONE`. If `INTERFACE_ADDRESSES`, the gateway port's IP address is used as this connection's site subnet. If `IP_ROUTES`, subnets are inferred from the gateway device's RIB. If `BGP_ROUTES`, subnets are inferred from the gateway device's Adj-RIB-Out.\n\nNote: If not `NONE`, routes are created on the node for both autodiscovered subnets and any subnets specified in `subnets`.\n\nNote: Using `BGP_ROUTES` will automatically enable collection of Adj-RIB-Out from the gateway device in future network collections.",
            "examples": [
              "NONE"
            ]
          },
          "peerIps": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "IP addresses of BGP peers to which this connection’s site subnets are advertised. If empty, routes advertised to all BGP peers are examined.\n\nNote: This set is only used if `subnetAutoDiscovery` is `BGP_ROUTES`.",
            "examples": [
              "- 1.1.1.1"
            ]
          },
          "backdoorLinkPorts": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/DevicePort"
            },
            "description": "L3 interfaces that provide backdoor connectivity between sites."
          },
          "advertisesDefaultRoute": {
            "type": "boolean",
            "description": "Whether this connection's gateway device advertises the default route. Defaults to `false`.\n\nNote: This property is only used if `subnetAutoDiscovery` is `IP_ROUTES`."
          }
        }
      },
      "InternetNode": {
        "type": "object",
        "required": [
          "name",
          "connections"
        ],
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "inet"
            ]
          },
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/InetConnection"
            }
          },
          "translations": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SyntheticNatEntry"
            }
          },
          "subnetsToExclude": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "Public subnets that should not be located at this device."
          }
        }
      },
      "InternetNodePatch": {
        "type": "object",
        "properties": {
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/InetConnection"
            },
            "description": "If specified, this list will **replace** all existing connections on the internet node."
          },
          "name": {
            "type": "string"
          },
          "translations": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SyntheticNatEntry"
            },
            "description": "If specified, this list will **replace** all existing translations on the internet node."
          },
          "subnetsToExclude": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "If specified, this list will **replace** all existing excluded subnets on the internet node."
          }
        }
      },
      "IntranetNode": {
        "type": "object",
        "required": [
          "name",
          "connections"
        ],
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "inet"
            ]
          },
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/InetConnection"
            }
          }
        }
      },
      "IntranetNodeList": {
        "type": "object",
        "required": [
          "intranetNodes"
        ],
        "properties": {
          "intranetNodes": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/IntranetNode"
            }
          }
        }
      },
      "IntranetNodePatch": {
        "type": "object",
        "properties": {
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/InetConnection"
            },
            "description": "If specified, this list will **replace** all existing connections on the intranet node."
          },
          "name": {
            "type": "string"
          }
        }
      },
      "L2Vpn": {
        "type": "object",
        "required": [
          "name",
          "connections"
        ],
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "l2vpn"
            ]
          },
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/L2VpnConnection"
            }
          }
        }
      },
      "L2VpnConnection": {
        "type": "object",
        "required": [
          "device",
          "port"
        ],
        "properties": {
          "device": {
            "type": "string",
            "description": "The customer edge device."
          },
          "port": {
            "type": "string",
            "description": "The physical edge port on the customer edge device.",
            "examples": [
              "eth1/1"
            ]
          },
          "vlan": {
            "type": "integer",
            "format": "int32",
            "examples": [
              100
            ]
          },
          "name": {
            "type": "string",
            "description": "An optional name for this connection, which will be used as the interface name created on the synthetic device that links to the customer edge device."
          }
        }
      },
      "L2VpnList": {
        "type": "object",
        "required": [
          "l2Vpns"
        ],
        "properties": {
          "l2Vpns": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/L2Vpn"
            }
          }
        }
      },
      "L2VpnPatch": {
        "type": "object",
        "properties": {
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/L2VpnConnection"
            },
            "description": "If specified, this list will **replace** all existing connections on the L2 VPN node."
          },
          "name": {
            "type": "string"
          }
        }
      },
      "L3Vpn": {
        "type": "object",
        "required": [
          "name",
          "connections"
        ],
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "l3vpn"
            ]
          },
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/L3VpnConnection"
            }
          }
        }
      },
      "L3VpnConnection": {
        "type": "object",
        "required": [
          "uplinkPort"
        ],
        "properties": {
          "uplinkPort": {
            "$ref": "#/components/schemas/DevicePort",
            "description": "The physical uplink port on the edge device.",
            "examples": [
              {
                "device": "nyc-rtr-01",
                "port": "eth1/1"
              }
            ]
          },
          "gatewayPort": {
            "$ref": "#/components/schemas/DevicePort",
            "description": "The virtual gateway port, if different than `uplinkPort`.",
            "examples": [
              {
                "device": "nyc-rtr-01",
                "port": "vlan100"
              }
            ]
          },
          "vrf": {
            "type": "string",
            "description": "An optional name for the VRF on the synthetic L3VPN device under which this connection resides."
          },
          "vlan": {
            "type": "integer",
            "format": "int32",
            "description": "The VLAN of traffic from `uplinkPort`, if tagged.",
            "examples": [
              100
            ]
          },
          "name": {
            "type": "string",
            "description": "An optional name for this connection, which will be used as the interface name created on the synthetic device that links to the physical edge port."
          },
          "site": {
            "type": "string",
            "description": "An optional name for the site in which this connection's gateway device resides. A site is a collection of devices that redistribute routes learned from an L3VPN to each other. Grouping connections together into a single site enables more accurate site subnet autodiscovery when using `IP_ROUTES` or `BGP_ROUTES`."
          },
          "subnets": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "Advertised subnets. Routes for these subnets are created on the L3VPN if received by another CE. Required (and must not be empty) if `subnetAutoDiscovery` is `NONE`.",
            "examples": [
              "- 123.223.47.0/24"
            ]
          },
          "subnetAutoDiscovery": {
            "$ref": "#/components/schemas/AutoDiscoverySource",
            "description": "The types of routes from which advertised subnets are automatically inferred in the gateway device’s routing table. Defaults to `NONE`. If `INTERFACE_ADDRESSES`, the gateway port’s IP address is used. If `IP_ROUTES`, subnets are inferred from the gateway device’s RIB. If `BGP_ROUTES`, subnets are inferred from the gateway device’s Adj-RIB-Out.\n\nNote: If not `NONE`, routes are created on the L3VPN for both autodiscovered subnets, as well any subnets specified in `subnets`, that are received by another CE.\n\nNote: Using `BGP_ROUTES` will automatically enable collection of Adj-RIB-Out from the gateway device in future network collections.",
            "examples": [
              "NONE"
            ]
          },
          "peerIps": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "description": "IP addresses of the provider edge devices to which this connection's edge device sends and receives L3VPN routes. If empty, routes advertised to all BGP peers are examined.",
            "examples": [
              "- 1.1.1.1"
            ]
          },
          "backdoorLinkPorts": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/DevicePort"
            },
            "description": "L3 interfaces that provide backdoor connectivity between sites."
          },
          "advertisesDefaultRoute": {
            "type": "boolean",
            "description": "Whether the CE advertises the default route. Defaults to `false`.\n\nNote: This property is only used if `subnetAutoDiscovery` is `IP_ROUTES`, which should be the case when BGP collection is not enabled on the CE. If the Adj-RIB-Out is not collected, the RIB is examined and a default route forwarded out `gatewayPort` is skipped if this property is false."
          }
        }
      },
      "L3VpnList": {
        "type": "object",
        "required": [
          "l3Vpns"
        ],
        "properties": {
          "l3Vpns": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/L3Vpn"
            }
          }
        }
      },
      "L3VpnPatch": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string"
          },
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/L3VpnConnection"
            },
            "description": "If specified, this list will **replace** all existing connections on the L3 VPN node."
          }
        }
      },
      "SyntheticConnection": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string"
          }
        }
      },
      "SyntheticConnections": {
        "type": "object",
        "properties": {
          "connections": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SyntheticConnection"
            }
          }
        }
      },
      "SyntheticNatEntry": {
        "type": "object",
        "required": [
          "insideAddress",
          "outsideAddress"
        ],
        "properties": {
          "insideAddress": {
            "type": "string",
            "examples": [
              "10.0.0.1"
            ]
          },
          "outsideAddress": {
            "type": "string",
            "description": "A public (non-RFC1918) address",
            "examples": [
              "1.1.1.1"
            ]
          }
        }
      },
      "WanCircuit": {
        "type": "object",
        "required": [
          "name",
          "connection1",
          "connection2"
        ],
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "wan-circuit-01"
            ]
          },
          "connection1": {
            "$ref": "#/components/schemas/WanCircuitConnection"
          },
          "connection2": {
            "$ref": "#/components/schemas/WanCircuitConnection"
          }
        }
      },
      "WanCircuitConnection": {
        "type": "object",
        "required": [
          "device",
          "port"
        ],
        "properties": {
          "device": {
            "type": "string",
            "description": "A customer edge device name"
          },
          "port": {
            "type": "string",
            "description": "The name of the connected port on `device`"
          },
          "vlan": {
            "type": "integer",
            "format": "int32",
            "description": "The VLAN of traffic from `port`, if tagged",
            "examples": [
              100
            ]
          },
          "name": {
            "type": "string",
            "description": "An optional name for this connection, which will be used as the interface name created on the synthetic device that links to the edge device."
          }
        }
      },
      "WanCircuitList": {
        "type": "object",
        "properties": {
          "wanCircuits": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/WanCircuit"
            }
          }
        }
      },
      "WanCircuitPatch": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "examples": [
              "wan-circuit-01"
            ]
          },
          "connection1": {
            "$ref": "#/components/schemas/WanCircuitConnection"
          },
          "connection2": {
            "$ref": "#/components/schemas/WanCircuitConnection"
          }
        }
      }
    },
    "securitySchemes": {
      "api_token": {
        "type": "http",
        "scheme": "basic"
      }
    }
  }
}